/* @C:\web_509\SQL\end_conv\oracle\4205_GOPTRGO_LOG_CALENDORCOPERAC.sql
   Trigger criada para gerar log das transaes na tabela GRUPGERENTEOP */

CREATE OR REPLACE TRIGGER LOG_CALENDORCOPERAC
AFTER DELETE OR UPDATE OR INSERT
ON CALENDORCOPERAC FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';

   IF DELETING THEN

      IF :OLD.NRANOORCOPERAC IS NOT NULL THEN
         V_DESC := V_DESC || ' AnoOrc=' || :OLD.NRANOORCOPERAC;
      END IF;

      IF :OLD.CDFASEORCOPERAC IS NOT NULL THEN
         V_DESC := V_DESC || ' CdFase=' || :OLD.CDFASEORCOPERAC;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.NRANOORCOPERAC||';'||:OLD.CDFASEORCOPERAC;
   ELSE
      IF UPDATING THEN
         IF (:OLD.DTINIFASEORCA  <> :NEW.DTINIFASEORCA) THEN
               V_DESC := V_DESC || ' DtInicio=' ||TO_CHAR(:NEW.DTINIFASEORCA);
         END IF;

         IF (:OLD.DTFINFASEORCA  <> :NEW.DTFINFASEORCA) THEN
               V_DESC := V_DESC || ' DtFinal=' ||TO_CHAR(:NEW.DTFINFASEORCA);
         END IF;

         IF (:OLD.IDPERMCALCJAN  <> :NEW.IDPERMCALCJAN) THEN
               V_DESC := V_DESC || ' IdPermJan=' ||:NEW.IDPERMCALCJAN;
         END IF;

         IF (:OLD.IDPERMCALCFEV  <> :NEW.IDPERMCALCFEV) THEN
               V_DESC := V_DESC || ' IdPermFev=' ||:NEW.IDPERMCALCFEV;
         END IF;

         IF (:OLD.IDPERMCALCMAR  <> :NEW.IDPERMCALCMAR) THEN
               V_DESC := V_DESC || ' IdPermMar=' ||:NEW.IDPERMCALCMAR;
         END IF;

         IF (:OLD.IDPERMCALCABR  <> :NEW.IDPERMCALCABR) THEN
               V_DESC := V_DESC || ' IdPermAbr=' ||:NEW.IDPERMCALCABR;
         END IF;

         IF (:OLD.IDPERMCALCMAI  <> :NEW.IDPERMCALCMAI) THEN
               V_DESC := V_DESC || ' IdPermMai=' ||:NEW.IDPERMCALCMAI;
         END IF;

         IF (:OLD.IDPERMCALCJUN  <> :NEW.IDPERMCALCJUN) THEN
               V_DESC := V_DESC || ' IdPermJun=' ||:NEW.IDPERMCALCJUN;
         END IF;

         IF (:OLD.IDPERMCALCJUL  <> :NEW.IDPERMCALCJUL) THEN
               V_DESC := V_DESC || ' IdPermJul=' ||:NEW.IDPERMCALCJUL;
         END IF;

         IF (:OLD.IDPERMCALCAGO  <> :NEW.IDPERMCALCAGO) THEN
               V_DESC := V_DESC || ' IdPermAgo=' ||:NEW.IDPERMCALCAGO;
         END IF;

         IF (:OLD.IDPERMCALCSET  <> :NEW.IDPERMCALCSET) THEN
               V_DESC := V_DESC || ' IdPermSet=' ||:NEW.IDPERMCALCSET;
         END IF;

         IF (:OLD.IDPERMCALCOUT  <> :NEW.IDPERMCALCOUT) THEN
               V_DESC := V_DESC || ' IdPermOut=' ||:NEW.IDPERMCALCOUT;
         END IF;

         IF (:OLD.IDPERMCALCNOV  <> :NEW.IDPERMCALCNOV) THEN
               V_DESC := V_DESC || ' IdPermNov=' ||:NEW.IDPERMCALCNOV;
         END IF;

         IF (:OLD.IDPERMCALCDEZ  <> :NEW.IDPERMCALCDEZ) THEN
               V_DESC := V_DESC || ' IdPermDez=' ||:NEW.IDPERMCALCDEZ;
         END IF;

            V_TIPO         := '2';
            V_ITPESQ       := :OLD.NRANOORCOPERAC||';'||:OLD.CDFASEORCOPERAC;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.NRANOORCOPERAC||';'||:NEW.CDFASEORCOPERAC;

         IF :NEW.NRANOORCOPERAC IS NOT NULL THEN
            V_DESC := V_DESC || ' AnoOrc=' || :NEW.NRANOORCOPERAC;
         END IF;

         IF :NEW.CDFASEORCOPERAC IS NOT NULL THEN
            V_DESC := V_DESC || ' CdFase=' || :NEW.CDFASEORCOPERAC;
         END IF;

      END IF; 


   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA, DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('CALENDORCOPERAC',  V_DTOPER, V_USUARIO,
                V_TIPO, V_ITPESQ, V_DESC, V_DSSERVERRDM,
                V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD,
                V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_CALENDORCOPERAC','5.09.000'); END;
/
