/******************************************************************************/
/*                                                                            */
/* Nome: CARREGA_PERIFILI SQL                                                 */
/*                                                                            */
/* Criao:                                                                   */
/*    05/12/2012 - Petterson Galdino                                          */
/*                                                                            */
/******************************************************************************/


IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE
            O.NAME = 'CARREGA_PERIFILI' AND
            TYPE = 'P'                  AND
            U.UID = O.UID               AND
            U.NAME = USER)
   DROP PROCEDURE CARREGA_PERIFILI
GO

CREATE PROCEDURE CARREGA_PERIFILI
                     ( @P_CDFILIAL        VARCHAR(4),
                       @P_CDPRODUTO       VARCHAR(10),
                       @P_DTPROGENTAF     DATETIME,
                       @P_ERRO            VARCHAR OUTPUT)
AS

   DECLARE @V_CDPERIENTR      VARCHAR(2);
   DECLARE @V_IDTIPODIA       VARCHAR(1);
   DECLARE @V_IDDIANUTIL      VARCHAR(1);
   DECLARE @V_DIENTREGA       VARCHAR(3);
   DECLARE @V_DTDIAENTR       VARCHAR(3);
   DECLARE @V_COUNT           NUMERIC;
   DECLARE @V_EXISTE          CHAR(1);
   DECLARE @V_DATA            DATETIME;
   DECLARE @V_NEW_DTPROGENTAF DATETIME;
   DECLARE @TESTE             VARCHAR(20);
BEGIN
   SET @P_ERRO  = 'N';
   SET @V_EXISTE = NULL;
   SELECT
         @V_CDPERIENTR = MAX(PERFILPROD.CDPERIENTR),
         @V_IDTIPODIA  = MAX(PERIENTR.IDTIPODIA),
         @V_IDDIANUTIL = MAX(PERIENTR.IDDIANUTIL)
     FROM PERFILPROD, PERIENTR
    WHERE PERFILPROD.CDFILIAL = @P_CDFILIAL
      AND PERFILPROD.CDPERIENTR = PERIENTR.CDPERIENTR
      AND PERFILPROD.CDPRODUTO = (SELECT MAX(B.CDARVPROD)
                                    FROM PERFILPROD A, PRODUTO B
                                   WHERE A.CDPRODUTO = B.CDPRODUTO
                                     AND A.CDFILIAL  = @P_CDFILIAL
                                     AND CHARINDEX(B.CDARVPROD, @P_CDPRODUTO) = 1);
   SET @V_EXISTE = NULL;
   SET @V_NEW_DTPROGENTAF = @P_DTPROGENTAF;
   IF @V_IDTIPODIA = 'S' BEGIN
      IF @V_IDDIANUTIL = 'S' BEGIN
         SELECT @V_DIENTREGA = MAX(DIENTREGA)
           FROM DIASENTR, DATA
          WHERE
             DATEPART(DW, DATA.DTDATA) = CONVERT(NUMERIC, DIASENTR.DIENTREGA) AND
             DIASENTR.CDPERIENTR = @V_CDPERIENTR AND
             (((DAY(DATA.DTDATA) + 6) / 7) + IDOCOR01 = 2 OR
             ((DAY(DATA.DTDATA) + 6) / 7) + IDOCOR02 = 3 OR
             ((DAY(DATA.DTDATA) + 6) / 7) + IDOCOR03 = 4 OR
             ((DAY(DATA.DTDATA) + 6) / 7) + IDOCOR04 = 5 OR
             ((DAY(DATA.DTDATA) + 6) / 7) + IDOCOR05 = 6) AND
            CONVERT(DATETIME, CONVERT(VARCHAR, DATA.DTDATA, 103)) = CONVERT(DATETIME, CONVERT(VARCHAR, @P_DTPROGENTAF, 103)) AND
            NOT EXISTS (SELECT 1
                          FROM FERICOMP
                         WHERE CDFILIAL   = @P_CDFILIAL
                           AND DTFERICOMP = @P_DTPROGENTAF);
         IF @V_DIENTREGA IS NULL BEGIN
            --ISERROR('TESTE123',16,1);
             SET @V_EXISTE = NULL;
         END
         ELSE BEGIN
            --ISERROR('TESTE2',16,1);
            SET @V_EXISTE = '1';
         END;
      END
      ELSE BEGIN
         SELECT @V_DIENTREGA = MAX(DIENTREGA)
           FROM DIASENTR,DATA
          WHERE
             DATEPART(DW, DATA.DTDATA) = CONVERT(NUMERIC, DIASENTR.DIENTREGA) AND
             DIASENTR.CDPERIENTR = @V_CDPERIENTR AND
             (((DAY(DATA.DTDATA) + 6) / 7) + IDOCOR01 = 2  OR
              ((DAY(DATA.DTDATA) + 6) / 7) + IDOCOR02 = 3 OR
              ((DAY(DATA.DTDATA) + 6) / 7) + IDOCOR03 = 4 OR
              ((DAY(DATA.DTDATA) + 6) / 7) + IDOCOR04 = 5 OR
              ((DAY(DATA.DTDATA) + 6) / 7) + IDOCOR05 = 6) AND
            CONVERT(DATETIME, CONVERT(VARCHAR, DATA.DTDATA, 103)) = CONVERT(DATETIME, CONVERT(VARCHAR, @P_DTPROGENTAF, 103));
         IF @V_DIENTREGA IS NULL BEGIN
            --ISERROR('TESTE123',16,1);
             SET @V_EXISTE = NULL;
         END
         ELSE BEGIN
            --ISERROR('TESTE2',16,1);
            SET @V_EXISTE = '1';
         END;
      END;
   END;
   IF @V_IDTIPODIA = 'R' BEGIN
      IF @V_IDDIANUTIL = 'S' BEGIN
         SELECT
            @V_DIENTREGA = MAX(DTENTREGA)
         FROM
            CALECOMP C
        WHERE C.CDFILIAL    = @P_CDFILIAL
           AND C.CDPERIENTR  = @V_CDPERIENTR
           AND C.DTENTREGA   = @P_DTPROGENTAF AND
           NOT EXISTS (SELECT 1
                         FROM FERICOMP
                        WHERE CDFILIAL = @P_CDFILIAL
                          AND DTFERICOMP = @P_DTPROGENTAF);
            IF @V_DIENTREGA IS NULL BEGIN
                --RAISERROR('TESTE123',16,1);
                SET @V_EXISTE = NULL;
            END
            ELSE BEGIN
             --RAISERROR('TESTE2',16,1);
               SET @V_EXISTE = '1';
            END;
      END
      ELSE BEGIN
         SELECT
            @V_DIENTREGA = MAX(DTENTREGA)
           FROM
             CALECOMP C
          WHERE C.CDFILIAL    = @P_CDFILIAL
                AND C.CDPERIENTR = @V_CDPERIENTR
                AND C.DTENTREGA  = @P_DTPROGENTAF
          IF @V_DIENTREGA IS NULL BEGIN
              --RAISERROR('TESTE123N',16,1);
              SET @V_EXISTE = NULL;
          END
          ELSE BEGIN
            --RAISERROR('TESTE2N',16,1);
             SET @V_EXISTE = '1';
          END;
      END;
   END;
   set @TESTE = @V_IDTIPODIA+'M';
   IF @V_IDTIPODIA = 'M' BEGIN
      SET @V_DIENTREGA  = NULL;
      IF @V_IDDIANUTIL = 'S' BEGIN
         SELECT @V_DIENTREGA = MAX(DIENTREGA)
         FROM
           (SELECT '-'+DIENTREGA DIENTREGA
            FROM DIASENTR
            WHERE CDPERIENTR = @V_CDPERIENTR
            UNION ALL
            SELECT DIENTREGA
            FROM DIASENTR
            WHERE CDPERIENTR = @V_CDPERIENTR) A
         WHERE
            DIENTREGA = SUBSTRING(CONVERT(VARCHAR, @P_DTPROGENTAF, 103), 1, 2) AND
               NOT EXISTS (SELECT 1
                             FROM FERICOMP
                            WHERE CDFILIAL   = @P_CDFILIAL
                              AND DTFERICOMP = @P_DTPROGENTAF);
         IF @V_DIENTREGA IS NULL BEGIN
             SET @V_EXISTE = NULL;
         END
         ELSE BEGIN
             SET @V_EXISTE = '1';
         END;
      END
      ELSE BEGIN
         SELECT @V_DIENTREGA = MAX(DIENTREGA)
           FROM
             (SELECT '-'+DIENTREGA DIENTREGA
              FROM DIASENTR
              WHERE CDPERIENTR = @V_CDPERIENTR
              UNION ALL
              SELECT DIENTREGA
              FROM DIASENTR
              WHERE CDPERIENTR = @V_CDPERIENTR) A
           WHERE
              DIENTREGA = SUBSTRING(CONVERT(VARCHAR, @P_DTPROGENTAF, 103), 1, 2);
         IF @V_DIENTREGA IS NULL BEGIN
            -- RAISERROR('TESTE123',16,1);
             SET @V_EXISTE = NULL;
         END
         ELSE BEGIN
           -- RAISERROR('TESTE2',16,1);
            SET @V_EXISTE = '1';
         END;
      END;
   END;
   IF @V_EXISTE IS NULL BEGIN
     SET @P_ERRO = 'S';
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'CARREGA_PERIFILI','5.50.xxx';
GO

