

/*+
|                                               |
|          Procedure: ETLCUSTOFOOD              |
|                                               |
|     TIPO DE CUSTO COMO DIMENSO               |
|    Custos e planejamento para o CVI.          |
|                                               |
|            Tabelas Preenchidas:               |
|                                               |
|       1:   ETL_RESUFOOD - Produtos            |
|       2:   ETL_RESUSERV - Servios            |
|                                               |
|@C:\web_511\sql\end_conv\sqlserver\9350_CVISTPS_ETL_ETLCUSTOFOOD.sql
+*/



IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
                       O.NAME = 'ETLCUSTOFOOD'  AND
                       TYPE = 'P'                  AND
                       U.UID = O.UID               AND
                       U.NAME = USER)

   DROP PROCEDURE ETLCUSTOFOOD
   GO


CREATE PROCEDURE ETLCUSTOFOOD @P_DTINI DATETIME,
                              @P_DTFINA DATETIME
AS

DECLARE   @V_COUNTER       INTEGER;
DECLARE   @V_DTFIM         DATETIME;
DECLARE   @V_DTINI         DATETIME;
DECLARE   @V_DATAFINAL     DATETIME;
DECLARE   @V_VRCUSTPADR    FLOAT;
DECLARE   @V_VRPRECVENDA   FLOAT;
DECLARE   @V_ZERO          FLOAT;
DECLARE   @V_CDSEQUENCIAL  VARCHAR(20);
DECLARE   @V_CDCLIENTE     VARCHAR(21);
DECLARE   @V_MES           VARCHAR(10);
DECLARE   @V_ANO           VARCHAR(10);
DECLARE   @V_BIM           VARCHAR(10);
DECLARE   @V_TRI           VARCHAR(10);
DECLARE   @V_SEM           VARCHAR(10);
DECLARE   @V_DTULTCOMEFE   DATETIME;
DECLARE   @w_C             CHAR;
DECLARE   @w_S             CHAR;
DECLARE   @w_N             CHAR;
DECLARE   @w_E             CHAR;
DECLARE   @V_TOTCUSTOPLAN  FLOAT;
DECLARE   @V_TOTCUSTOREAL  FLOAT;
DECLARE   @V_STAUX         VARCHAR(12);
DECLARE   @V_STAUX2         VARCHAR(12);
/*   -----VARIAVEIS CURSOR C_NRTPCUS-----*/
DECLARE @V_NRTIPOCUSTO DOUBLE PRECISION;
DECLARE @V_DSTIPOCUSTO VARCHAR(12);


/*   -----VARIAVEIS CURSOR C_ETL-----*/
DECLARE @V_CDAREAGERE      VARCHAR(03);
DECLARE @V_CDSUPERVISOR    VARCHAR(12);
DECLARE @V_CDGOPERAC       VARCHAR(12);
DECLARE @V_CDSEGMER        VARCHAR(05);
DECLARE @V_CDFILIAL        VARCHAR(12);
DECLARE @V_CDEMPRESA       VARCHAR(12);
DECLARE @V_DTINICIALBI     DATETIME;
DECLARE @V_DTPROCESSA      DATETIME;
DECLARE @V_IDCOMCUSPERC    VARCHAR(1);


/*   -----VARIAVEIS CURSOR C_SERVICO-----*/
DECLARE @V_CDSERVFILI     VARCHAR(12);
DECLARE @V_CDGRUPSERV     VARCHAR(12);
DECLARE @V_IDSERVPRINC    VARCHAR(1);
DECLARE @V_QTCOMESTICAR   DOUBLE PRECISION;
DECLARE @V_QTCOMEFETCAR   DOUBLE PRECISION;


/*   -----VARIAVEIS CURSOR C_PRODUTO-----*/
DECLARE @V_CDPRODFILI     VARCHAR(12);
DECLARE @V_CDPRODUTO      VARCHAR(12);
DECLARE @V_CUSTOPLAN      DOUBLE PRECISION;
DECLARE @V_CUSTOREAL      DOUBLE PRECISION;
DECLARE @V_QTCONSPLAN     DOUBLE PRECISION;
DECLARE @V_QTRETIRADA     DOUBLE PRECISION;


BEGIN

   SET @V_COUNTER = 0;
   SET @V_VRCUSTPADR = 0;
   SET @V_VRPRECVENDA = 0;
   SET @V_CDCLIENTE  = NULL;
   SET @w_C = 'C';
   SET @w_S = 'S';
   SET @w_N = 'N';
   SET @w_E = 'E';
   SET @V_TOTCUSTOPLAN  = 0;
   SET @V_TOTCUSTOREAL  = 0;
   SET @V_MES  =  (CONVERT (VARCHAR, MONTH (@P_DTINI)));
   SET @V_ANO  =  (CONVERT (VARCHAR, YEAR  (@P_DTINI)));

   BEGIN TRANSACTION;
   DELETE FROM ETL_RESUSERV
    WHERE CDANOBI > @V_ANO
      OR (CDANOBI = @V_ANO AND CDMESBI >= @V_MES);

   DELETE FROM ETL_RESUFOOD
    WHERE CDANOBI > @V_ANO
      OR (CDANOBI = @V_ANO AND CDMESBI >= @V_MES);
   COMMIT TRANSACTION;
   
   DECLARE C_NRTPCUS CURSOR FOR
      SELECT CONVERT(INT, CDTIPOCUSTO) NRTIPOCUSTO, CDTIPOCUSTO as DSTIPOCUSTO
         FROM TIPOCUSTO
        WHERE IDTPCUSTOGSC = @w_S
     ORDER BY NRTIPOCUSTO

   OPEN C_NRTPCUS;
   FETCH NEXT FROM C_NRTPCUS INTO
                  @V_NRTIPOCUSTO, @V_DSTIPOCUSTO;
   WHILE (@@FETCH_STATUS = 0) BEGIN

      SET @V_MES  =  (CONVERT (VARCHAR, MONTH (@P_DTINI)));
      SET @V_ANO  =  (CONVERT (VARCHAR, YEAR  (@P_DTINI)));
      SET @V_DTINI = CONVERT(DATETIME,('01/'+@V_MES+'/'+@V_ANO),103);

      WHILE (@V_DTINI  <=  @P_DTFINA)    BEGIN
         BEGIN TRANSACTION;
         SET @V_DTFIM =  DATEADD(MM, 1,@V_DTINI);
         SET @V_DTFIM =  DATEADD(DD,-1,@V_DTFIM);

         SET @V_MES  =  (CONVERT (VARCHAR, MONTH (@V_DTFIM)));
         SET @V_ANO  =  (CONVERT (VARCHAR, YEAR  (@V_DTFIM)));

         SET @V_BIM        =   CONVERT (VARCHAR,FLOOR((@V_MES - 1) / 2) + 1);
         SET @V_TRI        =   CONVERT (VARCHAR,FLOOR((@V_MES - 1) / 3) + 1);
         SET @V_SEM        =   CONVERT (VARCHAR,FLOOR((@V_MES - 1) / 6) + 1);

         DECLARE C_ETL CURSOR FOR
            SELECT
                    FL.CDFILIAL,        FL.CDAREAGERE,          FL.DTINICIALBI,
                    FL.CDSUPERVISOR,    FL.CDGOPERAC,           FL.CDEMPRESA,
                    FL.CDSEGMER,        P.DTPROCESSA,           P.IDCOMCUSPERC
              FROM
                    FILIAL FL, PARAMFILIAL P
              WHERE P.CDFILIAL = FL.CDFILIAL  AND P.CDFILIAL = '9999'
                AND FL.IDFUNCAOFILI IS NULL
                AND FL.DTINICIALBI  IS NOT NULL
                AND ISNULL(IDCTRLESTQ, @w_S) <> @w_N
                AND ISNULL(IDCNTRRESC, @w_N) <> @w_S
               ORDER BY FL.CDFILIAL

         OPEN C_ETL;
         FETCH NEXT FROM C_ETL INTO
                               @V_CDFILIAL,      @V_CDAREAGERE,  @V_DTINICIALBI,
                               @V_CDSUPERVISOR,  @V_CDGOPERAC,   @V_CDEMPRESA,
                               @V_CDSEGMER,      @V_DTPROCESSA,  @V_IDCOMCUSPERC;

         WHILE (@@FETCH_STATUS = 0) BEGIN

         IF (CONVERT (DATETIME, ('01' + '/' + CONVERT(VARCHAR, MONTH(@V_DTINICIALBI))+'/'+ CONVERT (VARCHAR, YEAR(@V_DTINICIALBI)))) <= @V_DTINI)
         BEGIN

               SET @V_STAUX = 'CONSPLAN'+@V_CDFILIAL;
               EXEC TEKNISA.NOVO_CODIGO @V_STAUX,@P_SEQUENCIAL = @V_CDSEQUENCIAL OUTPUT,@P_QTDE = 1;
               SET @V_CDSEQUENCIAL = SUBSTRING(@V_CDSEQUENCIAL,11,10);

               IF CONVERT(DATETIME, (@V_DTPROCESSA - 1), 103) <=   CONVERT(DATETIME, @V_DTFIM, 103)
                  SET @V_DATAFINAL = CONVERT(DATETIME, (@V_DTPROCESSA - 1), 103);
               ELSE
                  SET @V_DATAFINAL = CONVERT(DATETIME, @V_DTFIM, 103);
               
               SET @V_STAUX = ('_' + CONVERT(VARCHAR(8), CONVERT(DATETIME, @V_DTINI), 112) + '_');
               SET @V_STAUX2 = ('_' + CONVERT(VARCHAR(8), CONVERT(DATETIME, @V_DTFIM), 112) + '_'); 

               EXEC TEKNISA.CONSUMO_PLANEJADO_PLA
                                     @V_CDFILIAL,
                                     'T',
                                     @V_DTINI,
                                     @V_DTFIM,
                                     'T',
                                     'CFP',
                                     'N',
                                      0,
                                     'N',
                                      @V_CDSEQUENCIAL,
                                     '0',
                                     'zzzzzzzzzz',
                                     '',
                                     @V_STAUX,
                                     @V_STAUX2;


               DECLARE C_SERVICO CURSOR FOR
                  SELECT SE.CDSERVFILI, SE.CDGRUPSERV,  SE.IDSERVPRINC,
                         SUM(CASE @V_IDCOMCUSPERC WHEN @w_C THEN CA.QTCLIESTICAR ELSE CA.QTCOMESTICAR END ) AS QTCOMESTICAR,
                         SUM(CASE @V_IDCOMCUSPERC WHEN @w_C THEN CA.QTCLIEFETCAR ELSE CA.QTCOMEFETCAR END) AS QTCOMEFETCAR
                   FROM CARDADIA CA, SERVICO SE
                   WHERE CA.CDFILIAL = @V_CDFILIAL
                     AND CA.CDFILIAL = SE.CDFILIAL
                     AND CA.CDSERVFILI = SE.CDSERVFILI
                     AND CA.DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFIM
                   GROUP BY SE.CDSERVFILI, SE.CDGRUPSERV,  SE.IDSERVPRINC
               
               OPEN C_SERVICO;
               FETCH NEXT FROM C_SERVICO INTO
                               @V_CDSERVFILI, @V_CDGRUPSERV, @V_IDSERVPRINC, @V_QTCOMESTICAR, @V_QTCOMEFETCAR;
               
               WHILE (@@FETCH_STATUS = 0) BEGIN

                     SELECT @V_DTULTCOMEFE = MAX(DTCARDAPIO)
                       FROM CARDADIA CA, SERVICO SE
                      WHERE CA.CDFILIAL = @V_CDFILIAL
                        AND CA.CDFILIAL = SE.CDFILIAL
                        AND CA.CDSERVFILI = SE.CDSERVFILI
                        AND QTCOMEFETCAR > 0
                        AND CA.DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFIM
                        AND SE.CDSERVFILI = @V_CDSERVFILI
                      GROUP BY SE.CDSERVFILI;

                     BEGIN
                        SELECT @V_VRCUSTPADR= ISNULL(MAX(VRCUSTPADR),@V_ZERO)
                        FROM   CUSTPADR
                        WHERE  CDFILIAL     = @V_CDFILIAL
                          AND  CDSERVFILI   = @V_CDSERVFILI
                          AND  DTREFCUSPADR = @V_DTINI;

                     END;

                     BEGIN
                        SELECT @V_CDCLIENTE = MAX(CF.CDCLIENTE)
                        FROM   CLIENFILIAL CF, CLIENTE B
                        WHERE  CF.CDFILIAL = @V_CDFILIAL
                           AND CF.CDCLIENTE = B.CDCLIENTE
                           AND CF.IDCLIENPRIN = @w_S;
                     END;


                     SET @V_VRPRECVENDA = @V_ZERO;
                     IF (@V_CDCLIENTE IS NOT NULL) BEGIN
                            SELECT @V_VRPRECVENDA = ISNULL(MAX(VRSERVFATHIS), @V_ZERO)
                            FROM HISTSERVFATU
                            WHERE CDFILIAL     = @V_CDFILIAL
                              AND CDSERVFILI   = @V_CDSERVFILI
                              AND CDCLIENTE    = @V_CDCLIENTE
                              AND DTSRVFATUHIS = (SELECT MAX(DTSRVFATUHIS)
                                                    FROM HISTSERVFATU
                                                   WHERE CDFILIAL     = @V_CDFILIAL
                                                     AND CDCLIENTE    = @V_CDCLIENTE
                                                     AND CDSERVFILI   = @V_CDSERVFILI
                                                     AND CONVERT(DATETIME, DTSRVFATUHIS , 103) <= @V_DATAFINAL);


                     END;

                     DECLARE C_PRODUTO CURSOR FOR

                        SELECT PR.CDFILIAL, PR.CDPRODUTO,
                            SUM(PR.CUSTOPLAN) AS CUSTOPLAN,
                            SUM(PR.CUSTOREAL) AS CUSTOREAL,
                            SUM(QTCONSPLAN) AS QTCONSPLAN,
                            SUM(QTRETIRADA) AS QTRETIRADA

                        FROM
                            SERVICO SE LEFT JOIN GRUPSERV GPS ON SE.CDGRUPSERV = GPS.CDGRUPSERV,
                            (SELECT
                               CDFILIAL, CDSERVFILI, DTCARDAPIO
                             FROM CARDADIA
                             WHERE
                                 CDFILIAL = @V_CDFILIAL AND
                                (CDSERVFILI = @V_CDSERVFILI) AND
                                (DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFIM)
                             GROUP BY CDFILIAL, CDSERVFILI, DTCARDAPIO) as  CD,
                            (SELECT CDFILIAL, CDSERVFILI, DTCARDAPIO,
                               SUM(CUSTOPLAN) CUSTOPLAN,
                               SUM(CUSTOREAL) CUSTOREAL,
                               SUM(QTCONSPLAN) QTCONSPLAN,
                               SUM(QTRETIRADA) QTRETIRADA,
                               CDPRODUTO
                             FROM
                             (SELECT CP.CDFILICPLA CDFILIAL, CP.CDSERVCPLA CDSERVFILI, CP.DTCONSPLAN DTCARDAPIO,
                                  ((TEKNISA.CUSTO_PRODUTO( CP.CDFILICPLA, CP.CDPRODCPLA, @V_NRTIPOCUSTO,
                                                 CASE PG.IDUTCARDPADR WHEN @w_S THEN CD.DTREFECUSTMES ELSE CP.DTCONSPLAN END,
                                                 GETDATE())) * CP.QTCONSPLAN) AS CUSTOPLAN,
                                  0 AS CUSTOREAL, CP.QTCONSPLAN, 0 AS QTRETIRADA,
                                  CP.CDPRODCPLA CDPRODUTO
                                  FROM
                                  CONSPLAN CP, PARAMGERAL PG,
                                  (SELECT CD.CDFILIAL, CD.CDSERVFILI, CD.DTMESCARD, MAX(CM.DTREFECUSTMES) AS DTREFECUSTMES
                                   FROM CARDADIA CD LEFT JOIN CARDAMES CM ON CD.CDFILIAL = CM.CDFILIAL AND CD.CDSERVFILI = CM.CDSERVFILI AND CD.DTMESCARD = CM.DTMESCARDAPIO
                                   WHERE (CD.CDFILIAL = @V_CDFILIAL)
                                     AND (CD.CDSERVFILI = @V_CDSERVFILI)
                                     AND (CD.DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFIM)
                                   GROUP BY CD.CDFILIAL, CD.CDSERVFILI, CD.DTMESCARD) CD
                                WHERE
                                  (CP.CDFILICPLA   = @V_CDFILIAL)    AND
                                  (CP.NRCONSPLAN   = @V_CDSEQUENCIAL)AND
                                  (CD.CDFILIAL     = CP.CDFILICPLA)  AND
                                  (CD.CDSERVFILI   = CP.CDSERVCPLA)  AND
                                  (PG.CDPARGERAL   = '0001')         AND
                                  (CD.DTMESCARD    = CONVERT (DATETIME, ('01' + '/' + CONVERT(VARCHAR, MONTH(CP.DTCONSPLAN))+'/'+ CONVERT (VARCHAR,YEAR(CP.DTCONSPLAN)))))
                               UNION ALL
                               SELECT CD.CDFILIAL, CD.CDSERVFILI, CD.DTCARDAPIO,
                                  CASE @V_NRTIPOCUSTO WHEN NULL THEN 0 ELSE ROUND(CNE.VRPLANNESTO * (RNE.PERATENESTO/100) * (CD.QTCOMESTICAR/H.TOTCOMEN), 5) END AS CUSTOPLAN,
                                  0 AS CUSTOREAL,
                                  CD.QTCOMESTICAR/H.TOTCOMEN AS QTCONSPLAN,
                                  0 QTRETIRADA,
                                  CNE.CDPRODUTO AS CDPRODUTO
                               FROM
                                  (SELECT
                                      DTMESCARD,  CDSERVFILI,
                                      SUM(QTCOMESTICAR) AS TOTCOMEN
                                   FROM CARDADIA
                                   WHERE
                                      (CDFILIAL = @V_CDFILIAL) AND
                                      (CDSERVFILI = @V_CDSERVFILI) AND
                                      (DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFIM)
                                   GROUP BY DTMESCARD, CDSERVFILI
                                  ) H,
                                  CARDADIA  CD, RATENESTO RNE, CUSTNESTO CNE, DATA      DT
                               WHERE
                                  (DT.DTDATA BETWEEN @V_DTINI AND @V_DTFIM)                            AND
                                  (CONVERT (VARCHAR, MONTH (DT.DTDATA)))+(CONVERT (VARCHAR, YEAR  (DT.DTDATA))) = (CONVERT (VARCHAR, MONTH (CNE.DTCUSTNESTO)))+(CONVERT (VARCHAR, YEAR  (CNE.DTCUSTNESTO))) AND--112
                                  (CNE.CDFILIAL     = @V_CDFILIAL)                                AND
                                  (RNE.CDSERVFILI = @V_CDSERVFILI)                            AND
                                  (CNE.CDPRODUTO    = RNE.CDPRODUTO)                                  AND
                                  (CD.CDFILIAL      = RNE.CDFILIAL)                                   AND
                                  (CD.CDSERVFILI    = RNE.CDSERVFILI)                                 AND
                                  (CD.DTCARDAPIO    = DT.DTDATA)                                      AND
                                  (H.DTMESCARD      = CD.DTMESCARD)                                   AND
                                  (H.CDSERVFILI     = RNE.CDSERVFILI)                                 AND
                                  (NOT H.TOTCOMEN IS NULL AND H.TOTCOMEN <> 0)
                               UNION ALL
                               SELECT C.CDFILIAL, C.CDSERVFILI, C.DTCARDAPIO,
                                  0 CUSTOPLAN,
                                  CASE @V_NRTIPOCUSTO WHEN NULL THEN 0 ELSE (C.QTRETIRADA * TEKNISA.CUSTO_PRODUTO(C.CDFILIAL, C.CDPRODUTO, @V_NRTIPOCUSTO, C.DTCARDAPIO, GETDATE())) END AS CUSTOREAL,
                                  0 AS QTCONSPLAN,
                                  C.QTRETIRADA,
                                  C.CDPRODUTO
                               FROM
                                  (SELECT
                                     CA.CDFILIAL, CA.CDSERVFILI,CA.DTCARDAPIO,
                                     SUM(IR.QTRETIRADA * PRA.VRFATOCONV) AS QTRETIRADA,
                                     PRB.CDPRODUTO
                                  FROM CARDADIA CA, PRODUTO  PRA, PRODUTO  PRB,  ITEMRETI IR
                                  WHERE
                                     (PRB.CDPRODUTO = PRA.CDPRODESTO)                  AND
                                     (PRA.CDPRODUTO = IR.CDPRODUTO)                    AND
                                     (CA.CDFILIAL   = IR.CDFILIAL)                     AND
                                     (CA.CDFILIAL   = @V_CDFILIAL )                 AND
                                     (CA.DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFIM)   AND
                                     (CA.CDSERVFILI = @V_CDSERVFILI)            AND
                                      (CA.NRCARDAPIO = IR.NRCARDAPIO)
                                  GROUP BY CA.CDFILIAL, CA.CDSERVFILI, CA.DTCARDAPIO, PRB.CDPRODUTO) C

                               UNION ALL
                               SELECT
                                  RNE.CDFILIAL, RNE.CDSERVFILI, DT.DTDATA      AS DTCARDAPIO,
                                  0 AS CUSTOPLAN,
                                  CASE @V_NRTIPOCUSTO WHEN NULL THEN 0 ELSE ROUND(CNE.VRREALNESTO * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5) END AS CUSTOREAL1,
                                  0 AS QTCONSPLAN,
                                  (CA.QTCOMEFETCAR/TC.TOTCOMEN) AS QTRETIRADA,
                                  CNE.CDPRODUTO AS CDPRODUTO
                               FROM
                                  (SELECT  DTMESCARD, CDSERVFILI,
                                      SUM(QTCOMEFETCAR) AS TOTCOMEN
                                   FROM CARDADIA
                                   WHERE
                                      (CDFILIAL = @V_CDFILIAL)                           AND
                                      (CDSERVFILI = @V_CDSERVFILI)                   AND
                                      (DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFIM)
                                   GROUP BY  DTMESCARD, CDSERVFILI
                                   ) TC, CARDADIA  CA, RATENESTO RNE, CUSTNESTO CNE,  DATA      DT
                               WHERE
                                  (DT.DTDATA BETWEEN @V_DTINI AND @V_DTFIM)                       AND
                                  (CNE.CDFILIAL    = @V_CDFILIAL)                                 AND
                                  (CONVERT (VARCHAR, MONTH (DT.DTDATA)))+(CONVERT (VARCHAR, YEAR (DT.DTDATA))) = (CONVERT (VARCHAR, MONTH (CNE.DTCUSTNESTO)))+(CONVERT (VARCHAR, YEAR  (CNE.DTCUSTNESTO))) AND
                                  (NOT CNE.VRREALNESTO IS NULL)                                       AND
                                  (RNE.CDFILIAL    = @V_CDFILIAL)                                 AND
                                  (RNE.CDSERVFILI = @V_CDSERVFILI)                            AND
                                  (RNE.CDPRODUTO   = CNE.CDPRODUTO)                                   AND
                                  (CA.CDFILIAL     = @V_CDFILIAL)                                 AND
                                  (CA.CDSERVFILI   = RNE.CDSERVFILI)                                  AND
                                  (CA.DTCARDAPIO   = DT.DTDATA)                                       AND
                                  (TC.DTMESCARD    = CA.DTMESCARD)                                    AND
                                  (TC.CDSERVFILI   = CA.CDSERVFILI)                                   AND
                                  (NOT TC.TOTCOMEN IS NULL AND TC.TOTCOMEN <> 0)
                               UNION ALL
                               SELECT
                                  RNE.CDFILIAL, RNE.CDSERVFILI, DT.DTDATA       AS DTCARDAPIO,
                                  0 AS CUSTOPLAN,
                                  CASE @V_NRTIPOCUSTO WHEN NULL THEN 0 ELSE ROUND(TCN.VRTOTAITEM * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5) END AS CUSTOREAL1,
                                  0 AS QTCONSPLAN,
                                  (CA.QTCOMEFETCAR/TC.TOTCOMEN) AS QTRETIRADA,
                                  TCN.CDPRODUTO CDPRODUTO
                               FROM DATA        DT, RATENESTO   RNE, CARDADIA    CA,
                                  (SELECT
                                      DTMESCARD, CDSERVFILI,
                                      SUM(QTCOMEFETCAR) AS TOTCOMEN
                                   FROM CARDADIA
                                   WHERE
                                      (CDFILIAL = @V_CDFILIAL)                           AND
                                      (CDSERVFILI = @V_CDSERVFILI)                   AND
                                      (DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFIM)
                                   GROUP BY DTMESCARD, CDSERVFILI
                                   ) TC,
                                   (SELECT
                                       (CONVERT (VARCHAR, MONTH (NF.DTENTRSAID)))+(CONVERT (VARCHAR, YEAR (NF.DTENTRSAID))) AS DTMESNF,
                                       IP.CDPRODUTO,
                                       SUM(IP.VRTOTAITEM) AS VRTOTAITEM
                                    FROM NOTAFISCAL  NF, ITEMPRODUTO IP
                                    WHERE
                                      (IP.CDFILIAL     = NF.CDFILIAL)                       AND
                                      (IP.NRLANCTONF   = NF.NRLANCTONF)                     AND
                                      (NF.CDFILIRECE   = @V_CDFILIAL)                   AND
                                      (NF.IDENTRSAIDOP = @w_E)                               AND
                                      (NF.DTENTRSAID BETWEEN @V_DTINI AND @V_DTFIM)
                                    GROUP BY
                                       (CONVERT (VARCHAR, MONTH (NF.DTENTRSAID)))+(CONVERT (VARCHAR, YEAR (NF.DTENTRSAID))),
                                       IP.CDPRODUTO
                                  ) TCN
                               WHERE
                                  (DT.DTDATA BETWEEN @V_DTINI AND @V_DTFIM)    AND
                                  ((CONVERT (VARCHAR, MONTH (DT.DTDATA)))+(CONVERT (VARCHAR, YEAR (DT.DTDATA)))= TCN.DTMESNF)   AND
                                  (RNE.CDFILIAL    = @V_CDFILIAL)             AND
                                  (RNE.CDSERVFILI  = @V_CDSERVFILI)        AND
                                  (CA.CDFILIAL     = @V_CDFILIAL)             AND
                                  (CA.CDSERVFILI   = RNE.CDSERVFILI)             AND
                                  (CA.DTCARDAPIO   = DT.DTDATA)                  AND
                                  (CA.DTCARDAPIO   = DT.DTDATA)                  AND
                                  (TCN.CDPRODUTO   = RNE.CDPRODUTO)              AND
                                  (TC.DTMESCARD    = CA.DTMESCARD)               AND
                                  (TC.CDSERVFILI   = CA.CDSERVFILI)              AND
                                  (NOT TC.TOTCOMEN IS NULL AND TC.TOTCOMEN <> 0) AND
                                  (NOT EXISTS (SELECT CDFILIAL
                                               FROM CUSTNESTO
                                               WHERE
                                                  CDFILIAL    = @V_CDFILIAL    AND
                                                  DTCUSTNESTO = DT.DTDATA          AND
                                                  CDPRODUTO   = RNE.CDPRODUTO      AND
                                                  NOT VRREALNESTO IS NULL))
                              ) AS SU
                              GROUP BY  CDFILIAL,
                                        CDSERVFILI,
                                        DTCARDAPIO,
                                        CDPRODUTO ) PR
                         WHERE
                            SE.CDFILIAL   = PR.CDFILIAL   AND
                            SE.CDSERVFILI = PR.CDSERVFILI AND
                            CD.CDFILIAL   = PR.CDFILIAL   AND
                            CD.CDSERVFILI = PR.CDSERVFILI AND
                            CD.DTCARDAPIO = PR.DTCARDAPIO 
                         GROUP BY PR.CDFILIAL, PR.CDSERVFILI,  PR.CDPRODUTO
                         ORDER BY PR.CDPRODUTO

                         OPEN C_PRODUTO;
                            FETCH NEXT FROM C_PRODUTO INTO
                              @V_CDPRODFILI, @V_CDPRODUTO, @V_CUSTOPLAN, @V_CUSTOREAL,  @V_QTCONSPLAN, @V_QTRETIRADA;

                         WHILE (@@FETCH_STATUS = 0) BEGIN

                           IF LEN (@V_MES) = 1 BEGIN 
                              SET @V_MES = '0'+@V_MES;   
                           END;

                           INSERT INTO ETL_RESUFOOD 
                             (CDFILIAL,  CDAREAGERE, CDSUPERVISOR, CDGOPERAC, CDEMPRESA, CDSEGMER,
                              CDPRODUTO, CDANOBI, CDMESBI, BIETLFOOD, TRETLFOOD, SEETLFOOD, CDGRUPSERV,
                              CDFILISERVFILI, CDTIPOCUSTO, QTETLCONPLAFOOD, QTETLRETIRAFOOD, VRETLCUSPLAFOOD,
                              VRETLCUSREAFOOD)
                           VALUES
                             (@V_CDFILIAL, @V_CDAREAGERE, @V_CDSUPERVISOR, @V_CDGOPERAC, @V_CDEMPRESA,
                              @V_CDSEGMER, @V_CDPRODUTO, @V_ANO, @V_MES, @V_BIM, @V_TRI, @V_SEM, @V_CDGRUPSERV,
                              @V_CDFILIAL+@V_CDSERVFILI, @V_DSTIPOCUSTO,
                              @V_QTCONSPLAN, @V_QTRETIRADA, @V_CUSTOPLAN, @V_CUSTOREAL);

                           SET @V_TOTCUSTOPLAN = @V_TOTCUSTOPLAN + @V_CUSTOPLAN;
                           SET @V_TOTCUSTOREAL = @V_TOTCUSTOREAL + @V_CUSTOREAL;
                        
                           FETCH NEXT FROM C_PRODUTO INTO
                              @V_CDPRODFILI, @V_CDPRODUTO, @V_CUSTOPLAN, @V_CUSTOREAL,  @V_QTCONSPLAN, @V_QTRETIRADA;
                         END;  -- FECHA LOOP DO CURSOR C_PRODUTO
                         CLOSE C_PRODUTO;
                         DEALLOCATE C_PRODUTO;

                     IF LEN (@V_MES) = 1 BEGIN 
                        SET @V_MES = '0'+@V_MES;   
                     END;

                     INSERT INTO ETL_RESUSERV
                        (CDFILIAL,   CDAREAGERE,  CDSUPERVISOR, CDGOPERAC,  CDEMPRESA,   CDSEGMER,
                        CDGRUPSERV, CDFILISERVFILI,  CDANOBI, CDMESBI,  BIETLSERV, TRETLSERV,
                        SEETLSERV,  CDTIPOCUSTO, QTCOMESTETLSERV,QTCOMEFEETLSERV, VRCUSPADETLSERV,
                        VRCUSVNDETLSERV, VRETLCUSPLASERV, VRETLCUSREASERV, DSDTPROCETLSERV, DSDTULTCOMEFE, DSTPSERVETLSERV)
                     VALUES
                        (@V_CDFILIAL, @V_CDAREAGERE, @V_CDSUPERVISOR, @V_CDGOPERAC, @V_CDEMPRESA,
                         @V_CDSEGMER, @V_CDGRUPSERV, @V_CDFILIAL+@V_CDSERVFILI,
                         @V_ANO, @V_MES, @V_BIM, @V_TRI, @V_SEM,  @V_DSTIPOCUSTO, @V_QTCOMESTICAR,
                         @V_QTCOMEFETCAR, @V_VRCUSTPADR,
                         @V_VRPRECVENDA, @V_TOTCUSTOPLAN, @V_TOTCUSTOREAL,
                         CONVERT(VARCHAR, @V_DTPROCESSA, 103), CONVERT(VARCHAR, @V_DTULTCOMEFE, 103),
                         CASE @V_IDSERVPRINC WHEN 'S' THEN 'Servio Principal' ELSE 'Outros Servios' END);
                      SET @V_TOTCUSTOPLAN = 0;
                      SET @V_TOTCUSTOREAL = 0;
                      FETCH NEXT FROM C_SERVICO INTO
                               @V_CDSERVFILI, @V_CDGRUPSERV, @V_IDSERVPRINC, @V_QTCOMESTICAR, @V_QTCOMEFETCAR;
               END; -- FECHA LOOP DO CURSOR C_SERVICO
               CLOSE C_SERVICO;
               DEALLOCATE C_SERVICO;
               DELETE FROM CONSPLAN
                WHERE NRCONSPLAN = @V_CDSEQUENCIAL;
               SET @V_COUNTER = @V_COUNTER + 1;
            END; -- FECHA IF DO CURSOR C_ETL
            IF @V_COUNTER > 100  BEGIN
               SET @V_COUNTER = 0;
            END; -- FECHA IF DO CONTADOR

         FETCH NEXT FROM C_ETL INTO
                               @V_CDFILIAL,      @V_CDAREAGERE,  @V_DTINICIALBI,
                               @V_CDSUPERVISOR,  @V_CDGOPERAC,   @V_CDEMPRESA,
                               @V_CDSEGMER,      @V_DTPROCESSA,  @V_IDCOMCUSPERC;
         END; -- FIM DO LOOP DO CURSOR C_ETL
         CLOSE C_ETL;
         DEALLOCATE C_ETL;
         SET @V_DTINI = DATEADD(MM, 1, @V_DTINI);
      COMMIT TRANSACTION;
      END;  -- fim do loop que compara (@V_DTINI  <=  @P_DTFINA)
   FETCH NEXT FROM C_NRTPCUS INTO
        @V_NRTIPOCUSTO, @V_DSTIPOCUSTO;
   END; -- fim do loop do cursor C_NRTCUS
   CLOSE C_NRTPCUS;
   DEALLOCATE C_NRTPCUS;
END;
GO
-- VERSAO --
EXEC ATUVEROBJ 'ETLCUSTOFOOD','5.11.000';
GO





